
UNIT MINES1;        (* Version 1.01 - 08-1993 *)

(* GRAPHISMES DU PROGRAMME DE JEU MINES.PAS *)

INTERFACE

Uses GRAPH,TXT,DOS,MINES0;

Procedure LIGNE(xx,yy,couleur:word;numero:byte);
   (* DESSIN D'UNE DES LIGNES D'UN CHIFFRE *)
Procedure CHIFFRE(endroit,montant:byte);
   (* DESSIN D'UN CHIFFRE *)
Procedure DESSINCOMPLET;
   (* DESSIN DE L'AIRE DE JEU - TAILLE VARIABLE SELON LE NIVEAU. *)
Procedure DESSINCURSEUR(ligne,colonne:byte;couleur:word);
   (* DESSIN DU CARRE MAUVE CLAIR DU CURSEUR *)
Procedure AFFICHERCASE(ligne,colonne:byte);
   (* DEVOILEMENT D'UNE CASE *)
Procedure DESSINMARQUE(ligne,colonne:byte);
   (* DESSIN D'UNE MARQUE SUR UNE CASE *)
Procedure DESSINMENUPRINCIPAL;
   (* DESSIN MENU DE DEMANDE DU NIVEAU DE JEU OU SORTIE DU PROGRAMME *)
Procedure LOUPIOTTE(fonction,couleur:word);
   (* DANS LE MENU PRINCIPAL, ALLUME OU ETEINT UNE "LAMPE" *)
Procedure MESSAGEFINDEPARTIE(casesrestantes:integer);
   (* FELICITATIONS OU NOMBRE DE CASES NON DEVOILEES *)
Procedure MESSAGEDERREUR(erreur:byte);
   (* PROCEDURE D'AFFICHAGE MESSAGE ERREUR DISQUE *)
Procedure TABLENOMJOUEUR;
   (* TABLE GRAPHIQUE DE LECTURE DU NOM DU JOUEUR *)
Procedure LETTRENOM(lettre:char;place:byte);
   (* AFFICHAGE LETTRE OU CURSEUR LORS DE LA LECTURE DU NOM DU JOUEUR *)
Procedure EFFACERBASECRAN;
   (* EFFACEMENT LECTURE NOM JOUEUR OU MESSAGE D'ERREUR DISQUE *)
Procedure TABLERESULTAT;
   (* FOND GRAPHIQUE D'AFFICHAGE DU CLASSEMENT *)


IMPLEMENTATION

Procedure LIGNE(xx,yy,couleur:word;numero:byte);
(* DESSIN D'UNE DES LIGNES D'UN CHIFFRE *)

Begin
  setcolor(couleur);
  case numero of
      1:begin   (* BARRE HORIZONTALE HAUT *)
          line(xx+3,yy,xx+11,yy);
          line(xx+2,yy+1,xx+12,yy+1);
          line(xx+3,yy+2,xx+11,yy+2);
        end;
      2:begin   (* BARRE HORIZONTALE MILIEU *)
          line(xx+3,yy+11,xx+11,yy+11);
          line(xx+2,yy+12,xx+12,yy+12);
          line(xx+3,yy+13,xx+11,yy+13);
        end;
      3:begin   (* BARRE HORIZONTALE BAS *)
          line(xx+3,yy+22,xx+11,yy+22);
          line(xx+2,yy+23,xx+12,yy+23);
          line(xx+3,yy+24,xx+11,yy+24);
        end;
      4:begin   (* BARRE VERTICALE HAUT GAUCHE *)
          line(xx,yy+3,xx,yy+10);
          line(xx+1,yy+2,xx+1,yy+11);
          line(xx+2,yy+3,xx+2,yy+10);
        end;
      5:begin   (* BARRE VERTICALE HAUT DROITE *)
          line(xx+12,yy+3,xx+12,yy+10);
          line(xx+13,yy+2,xx+13,yy+11);
          line(xx+14,yy+3,xx+14,yy+10);
        end;
      6:begin   (* BARRE VERTICALE BAS GAUCHE *)
          line(xx,yy+14,xx,yy+21);
          line(xx+1,yy+13,xx+1,yy+22);
          line(xx+2,yy+14,xx+2,yy+21);
        end;
      7:begin   (* BARRE VERTICALE BAS DROITE *)
          line(xx+12,yy+14,xx+12,yy+21);
          line(xx+13,yy+13,xx+13,yy+22);
          line(xx+14,yy+14,xx+14,yy+21);
        end;
    end;
End;


Procedure CHIFFRE(endroit,montant:byte);
(* DESSIN D'UN CHIFFRE D'UN COMPTEUR *)

Var xx,yy:word;

Begin
  case endroit of
      1:begin xx:=x[33];yy:=y[33]; end;
      2:begin xx:=x[37];yy:=y[37]; end;
      3:begin xx:=x[41];yy:=y[41]; end;
      4:begin xx:=x[45];yy:=y[45]; end;
      5:begin xx:=x[49];yy:=y[49]; end;
      6:begin xx:=x[53];yy:=y[53]; end;
    end;
  case montant of
      0:begin
          LIGNE(xx,yy,yellow,2);
          LIGNE(xx,yy,black,1);
          LIGNE(xx,yy,black,3);
          LIGNE(xx,yy,black,4);
          LIGNE(xx,yy,black,5);
          LIGNE(xx,yy,black,6);
          LIGNE(xx,yy,black,7);
        end;
      1:begin
          LIGNE(xx,yy,yellow,1);
          LIGNE(xx,yy,yellow,2);
          LIGNE(xx,yy,yellow,3);
          LIGNE(xx,yy,yellow,4);
          LIGNE(xx,yy,yellow,6);
          LIGNE(xx,yy,black,5);
          LIGNE(xx,yy,black,7);
        end;
      2:begin
          LIGNE(xx,yy,yellow,7);
          LIGNE(xx,yy,black,1);
          LIGNE(xx,yy,black,2);
          LIGNE(xx,yy,black,3);
          LIGNE(xx,yy,black,5);
          LIGNE(xx,yy,black,6);
        end;
      3:begin
          LIGNE(xx,yy,yellow,4);
          LIGNE(xx,yy,yellow,6);
          LIGNE(xx,yy,black,1);
          LIGNE(xx,yy,black,2);
          LIGNE(xx,yy,black,3);
          LIGNE(xx,yy,black,5);
          LIGNE(xx,yy,black,7);
        end;
      4:begin
          LIGNE(xx,yy,yellow,1);
          LIGNE(xx,yy,yellow,3);
          LIGNE(xx,yy,black,2);
          LIGNE(xx,yy,black,4);
          LIGNE(xx,yy,black,5);
          LIGNE(xx,yy,black,7);
        end;
      5:begin
          LIGNE(xx,yy,yellow,5);
          LIGNE(xx,yy,yellow,6);
          LIGNE(xx,yy,black,1);
          LIGNE(xx,yy,black,2);
          LIGNE(xx,yy,black,3);
          LIGNE(xx,yy,black,4);
          LIGNE(xx,yy,black,7);
        end;
      6:begin
          LIGNE(xx,yy,yellow,5);
          LIGNE(xx,yy,black,1);
          LIGNE(xx,yy,black,2);
          LIGNE(xx,yy,black,3);
          LIGNE(xx,yy,black,4);
          LIGNE(xx,yy,black,6);
          LIGNE(xx,yy,black,7);
        end;
      7:begin
          LIGNE(xx,yy,yellow,2);
          LIGNE(xx,yy,yellow,3);
          LIGNE(xx,yy,yellow,4);
          LIGNE(xx,yy,yellow,6);
          LIGNE(xx,yy,black,5);
          LIGNE(xx,yy,black,7);
        end;
      8:begin
          LIGNE(xx,yy,yellow,6);
          LIGNE(xx,yy,black,1);
          LIGNE(xx,yy,black,2);
          LIGNE(xx,yy,black,3);
          LIGNE(xx,yy,black,4);
          LIGNE(xx,yy,black,5);
          LIGNE(xx,yy,black,6);
          LIGNE(xx,yy,black,7);
        end;
      9:begin
          LIGNE(xx,yy,yellow,6);
          LIGNE(xx,yy,black,1);
          LIGNE(xx,yy,black,2);
          LIGNE(xx,yy,black,3);
          LIGNE(xx,yy,black,4);
          LIGNE(xx,yy,black,5);
          LIGNE(xx,yy,black,7);
        end;
    end;
End;


Procedure TOUCHEDECOMMANDE(laquelle:byte;x,y:word);
(* DESSIN DES MOTIFS DES TOUCHES DE COMMANDE "RECOMMENCER" ET "SORTIE" *)

Begin
  case laquelle of
      1:begin   (* TOUCHE "RECOMMENCER" *)
          setcolor(black);
          arc(x+18,y+25,45,360,6);
          arc(x+18,y+25,45,360,7);
          line(x+23,y+26,x+26,y+26);
          line(x+22,y+27,x+27,y+27);
          setcolor(magenta);
          outtextxy(x+18,y+8,'F8');
        end;
      2:begin   (* TOUCHE "SORTIE" *)
          setcolor(black);
          line(x+12,y+23,x+15,y+23);
          line(x+12,y+24,x+15,y+24);
          line(x+12,y+25,x+12,y+30);
          line(x+13,y+25,x+13,y+30);
          line(x+12,y+31,x+23,y+31);
          line(x+12,y+32,x+23,y+32);
          line(x+22,y+25,x+22,y+30);
          line(x+23,y+25,x+23,y+30);
          line(x+20,y+23,x+23,y+23);
          line(x+20,y+24,x+23,y+24);
          line(x+17,y+21,x+17,y+26);
          line(x+18,y+21,x+18,y+26);
          line(x+15,y+20,x+20,y+20);
          line(x+16,y+19,x+19,y+19);
          line(x+17,y+18,x+18,y+18);
          setcolor(red);
          outtextxy(x+18,y+8,'F10');
        end;
    end;
End;


Procedure DESSINCOMPLET;

Var coord,xx1,yy1,xx2,yy2,xx3,yy3,xx4,yy4:word;
    m,n:byte;

Begin
  setlinestyle(solidln,0,1);
  setbkcolor(black);
  setviewport(x[29],y[29],x[32],y[32],clipon);
  clearviewport;
  setcolor(grey);
  (* CONTOUR GENERAL ET REMPLISSAGE *)
  rectangle(x[1],y[1],x[4],y[4]);
  setfillstyle(solidfill,cyan);
  floodfill(x[1]+1,y[1]+1,grey);
  (* COMPTEUR DE MINES *)
  rectangle(x[5],y[5],x[8],y[8]);
  setfillstyle(solidfill,yellow);
  floodfill(x[5]+1,y[5]+1,grey);
  CHIFFRE(minesgauche,minescentaines);
  CHIFFRE(minescentre,minesdizaines);
  CHIFFRE(minesdroite,minesunites);
  (* HORLOGE *)
  setcolor(grey);
  rectangle(x[9],y[9],x[12],y[12]);
  setfillstyle(solidfill,yellow);
  floodfill(x[9]+1,y[9]+1,grey);
  CHIFFRE(horlogegauche,centaines);
  CHIFFRE(horlogecentre,dizaines);
  CHIFFRE(horlogedroite,unites);
  (* TOUCHE "RECOMMENCER" *)
  setcolor(grey);
  rectangle(x[13],y[13],x[16],y[16]);
  (* TOUCHE "SORTIE" *)
  rectangle(x[21],y[21],x[24],y[24]);
  (* LA GRILLE ENTIERE *)
  coord:=y[25];
  for n:=1 to (nblignes+1) do
    begin
      line(x[25],coord,x[26],coord);
      inc(coord,(nbpixv+1));
    end;
  coord:=x[25];
  for n:=1 to (nbcolonnes+1) do
    begin
      line(coord,y[25],coord,y[27]);
      inc(coord,(nbpixh+1));
    end;
  (* ----- SIMULATION DES OMBRES ----- *)
  (* COMPTEUR DE MINES *)
  setcolor(black);
  line(x[5]+1,y[5]+1,x[6]-1,y[6]+1);
  line(x[5]+1,y[5]+2,x[6]-2,y[6]+2);
  line(x[6]-1,y[6]+1,x[8]-1,y[8]-1);
  line(x[6]-2,y[6]+2,x[8]-2,y[8]-1);
  (* HORLOGE *)
  line(x[9]+1,y[9]+1,x[10]-1,y[10]+1);
  line(x[9]+1,y[9]+2,x[10]-2,y[10]+2);
  line(x[10]-1,y[10]+1,x[12]-1,y[12]-1);
  line(x[10]-2,y[10]+2,x[12]-2,y[12]-1);
  (* CONTOUR GENERAL *)
  setcolor(grey);
  line(x[1]+1,y[1]+1,x[3]+1,y[3]-1);
  line(x[1]+2,y[1]+2,x[3]+2,y[3]-2);
  line(x[3]+1,y[3]-1,x[4]-1,y[4]-1);
  line(x[3]+2,y[3]-2,x[4]-2,y[4]-2);
  setcolor(lightcyan);
  line(x[1]+1,y[1]+1,x[2]-1,y[2]+1);
  line(x[1]+2,y[1]+2,x[2]-2,y[2]+2);
  line(x[2]-1,y[2]+1,x[4]-1,y[4]-1);
  line(x[2]-2,y[2]+2,x[4]-2,y[4]-2);
  (* TOUCHE "RECOMMENCER" *)
  setcolor(grey);
  line(x[13]+1,y[13]+1,x[15]+1,y[15]-1);
  line(x[13]+2,y[13]+2,x[15]+2,y[15]-2);
  line(x[15]+1,y[15]-1,x[16]-1,y[16]-1);
  line(x[15]+2,y[15]-2,x[16]-2,y[16]-2);
  setcolor(lightcyan);
  line(x[13]+1,y[13]+1,x[14]-1,y[14]+1);
  line(x[13]+2,y[13]+2,x[14]-2,y[14]+2);
  line(x[14]-1,y[14]+1,x[16]-1,y[16]-1);
  line(x[14]-2,y[14]+2,x[16]-2,y[16]-2);
  (* TOUCHE "SORTIE" *)
  setcolor(grey);
  line(x[21]+1,y[21]+1,x[23]+1,y[23]-1);
  line(x[21]+2,y[21]+2,x[23]+2,y[23]-2);
  line(x[23]+1,y[23]-1,x[24]-1,y[24]-1);
  line(x[23]+2,y[23]-2,x[24]-2,y[24]-2);
  setcolor(lightcyan);
  line(x[21]+1,y[21]+1,x[22]-1,y[22]+1);
  line(x[21]+2,y[21]+2,x[22]-2,y[22]+2);
  line(x[22]-1,y[22]+1,x[24]-1,y[24]-1);
  line(x[22]-2,y[22]+2,x[24]-2,y[24]-2);
  (* LA GRILLE *)
  for m:=0 to (nblignes-1) do
    for n:=0 to (nbcolonnes-1) do
      begin
        xx1:=x[25]+n*(nbpixh+1);yy1:=y[25]+m*(nbpixv+1);
        xx2:=xx1+nbpixh+1;yy2:=yy1;
        xx3:=xx1;yy3:=yy1+nbpixv+1;
        xx4:=xx2;yy4:=yy3;
        setcolor(grey);
        line(xx1+1,yy1+1,xx3+1,yy3-1);
        line(xx1+2,yy1+2,xx3+2,yy3-2);
        line(xx3+1,yy3-1,xx4-1,yy4-1);
        line(xx3+2,yy3-2,xx4-2,yy4-2);
        setcolor(lightcyan);
        line(xx1+1,yy1+1,xx2-1,yy2+1);
        line(xx1+2,yy1+2,xx2-2,yy2+2);
        line(xx2-1,yy2+1,xx4-1,yy4-1);
        line(xx2-2,yy2+2,xx4-2,yy4-2);
      end;
  (* ----- MOTIFS SUR LES TOUCHES DE COMMANDE ----- *)
  TOUCHEDECOMMANDE(1,x[13],y[13]);
  TOUCHEDECOMMANDE(2,x[21],y[21]);
End;


Procedure DESSINCURSEUR(ligne,colonne:byte;couleur:word);
(* DESSIN DU CARRE MAUVE CLAIR DU CURSEUR *)

Var xx1,yy1,xx2,yy2,xx3,yy3,xx4,yy4:word;
    m,n:byte;
    couleurcourante,xcourant,ycourant:word;

Begin
  xcourant:=getx;ycourant:=gety;
  couleurcourante:=getcolor;
  m:=ligne-1;
  n:=colonne-1;
  xx1:=x[25]+n*(nbpixh+1);yy1:=y[25]+m*(nbpixv+1);
  xx2:=xx1+nbpixh+1;yy2:=yy1;
  xx3:=xx1;yy3:=yy1+nbpixv+1;
  xx4:=xx2;yy4:=yy3;
  setcolor(couleur);
  if grille[colonne,ligne]>=100
     then
       begin
         line(xx1+1,yy1+1,xx2-1,yy2+1);
         line(xx1+1,yy1+2,xx2-1,yy2+2);
         line(xx1+1,yy1+1,xx3+1,yy3-1);
         line(xx1+2,yy1+1,xx3+2,yy3-1);
         line(xx3+1,yy3-1,xx4-1,yy4-1);
         line(xx3+1,yy3-2,xx4-1,yy4-2);
         line(xx2-1,yy2+1,xx4-1,yy4-1);
         line(xx2-2,yy2+1,xx4-2,yy4-1);
       end
     else
       begin
         inc(xx1,3);inc(yy1,3);
         dec(xx2,3);inc(yy2,3);
         inc(xx3,3);dec(yy3,3);
         dec(xx4,3);dec(yy4,3);
         line(xx1,yy1,xx2,yy2);
         line(xx1,yy1+1,xx2,yy2+1);
         line(xx1,yy1,xx3,yy3);
         line(xx1+1,yy1,xx3+1,yy3);
         line(xx3,yy3,xx4,yy4);
         line(xx3,yy3-1,xx4,yy4-1);
         line(xx2,yy2,xx4,yy4);
         line(xx2-1,yy2,xx4-1,yy4);
       end;
  setcolor(couleurcourante);
  moveto(xcourant,ycourant);
end;


Procedure AFFICHERCASE(ligne,colonne:byte);
(* DEVOILEMENT D'UNE CASE *)

Var m,n:byte;
    xx1,yy1,xx2,yy2,xx3,yy3,xx4,yy4:word;
    couleurcourante,xcourant,ycourant:word;

Begin
  xcourant:=getx;ycourant:=gety;
  couleurcourante:=getcolor;
  m:=ligne-1;
  n:=colonne-1;
  xx1:=x[25]+n*(nbpixh+1);yy1:=y[25]+m*(nbpixv+1);
  xx2:=xx1+nbpixh+1;yy2:=yy1;
  xx3:=xx1;yy3:=yy1+nbpixv+1;
  xx4:=xx2;yy4:=yy3;
  (* EFFACEMENT DE LA CASE *)
  setlinestyle(solidln,0,1);
  setcolor(cyan);
  for m:=1 to 21 do
    line(xx1+1,yy1+m,xx1+21,yy1+m);
  (* AFFICHAGE DU CHIFFRE OU DE LA MINE *)
  settextjustify(centertext,centertext);
  settextstyle(triplexfont,horizdir,1);
  case grille[colonne,ligne] of
      1:begin   (* "1" *)
          inc(xx1,4);inc(yy1,4);
          setcolor(blue);
          line(xx1+7,yy1,xx1+7,yy1+13);
          line(xx1+8,yy1,xx1+8,yy1+13);
          line(xx1+5,yy1+2,xx1+5,yy1+2);
          line(xx1+6,yy1+1,xx1+6,yy1+2);
          line(xx1+5,yy1+14,xx1+10,yy1+14);
        end;
      2:begin   (* "2" *)
          inc(xx1,4);inc(yy1,4);
          setcolor(brown);
          line(xx1+2,yy1+2,xx1+2,yy1+5);
          line(xx1+3,yy1+2,xx1+3,yy1+5);
          line(xx1+3,yy1+1,xx1+4,yy1+1);
          line(xx1+5,yy1,xx1+9,yy1);
          line(xx1+10,yy1+1,xx1+11,yy1+1);
          line(xx1+11,yy1+2,xx1+11,yy1+5);
          line(xx1+12,yy1+2,xx1+12,yy1+5);
          line(xx1+10,yy1+6,xx1+11,yy1+6);
          line(xx1+9,yy1+7,xx1+10,yy1+7);
          line(xx1+7,yy1+8,xx1+8,yy1+8);
          line(xx1+5,yy1+9,xx1+6,yy1+9);
          line(xx1+4,yy1+10,xx1+4,yy1+10);
          line(xx1+2,yy1+12,xx1+2,yy1+14);
          line(xx1+3,yy1+11,xx1+3,yy1+14);
          line(xx1+4,yy1+13,xx1+11,yy1+13);
          line(xx1+5,yy1+12,xx1+9,yy1+12);
          line(xx1+11,yy1+14,xx1+12,yy1+14);
        end;
      3:begin   (* "3" *)
          inc(xx1,4);inc(yy1,4);
          setcolor(red);
          line(xx1+2,yy1+2,xx1+2,yy1+4);
          line(xx1+3,yy1+2,xx1+3,yy1+4);
          line(xx1+3,yy1+1,xx1+4,yy1+1);
          line(xx1+5,yy1,xx1+9,yy1);
          line(xx1+10,yy1+1,xx1+11,yy1+1);
          line(xx1+11,yy1+2,xx1+11,yy1+5);
          line(xx1+12,yy1+2,xx1+12,yy1+5);
          line(xx1+9,yy1+6,xx1+11,yy1+6);
          line(xx1+6,yy1+7,xx1+10,yy1+7);
          line(xx1+9,yy1+8,xx1+11,yy1+8);
          line(xx1+11,yy1+9,xx1+11,yy1+12);
          line(xx1+12,yy1+9,xx1+12,yy1+12);
          line(xx1+10,yy1+13,xx1+11,yy1+13);
          line(xx1+5,yy1+14,xx1+9,yy1+14);
          line(xx1+3,yy1+13,xx1+4,yy1+13);
          line(xx1+2,yy1+10,xx1+2,yy1+12);
          line(xx1+3,yy1+10,xx1+3,yy1+12);
        end;
      4:begin   (* "4" *)
          inc(xx1,4);inc(yy1,4);
          setcolor(magenta);
          line(xx1+9,yy1,xx1+9,yy1+14);
          line(xx1+10,yy1,xx1+10,yy1+14);
          line(xx1+2,yy1+11,xx1+12,yy1+11);
          line(xx1+9,yy1,xx1+2,yy1+10);
        end;
      5:begin   (* "5" *)
          inc(xx1,4);inc(yy1,4);
          setcolor(grey);
          line(xx1+11,yy1,xx1+12,yy1);
          line(xx1+4,yy1+1,xx1+11,yy1+1);
          line(xx1+5,yy1+2,xx1+9,yy1+2);
          line(xx1+3,yy1,xx1+3,yy1+1);
          line(xx1+2,yy1,xx1+2,yy1+7);
          line(xx1+3,yy1+7,xx1+3,yy1+7);
          line(xx1+4,yy1+6,xx1+9,yy1+6);
          line(xx1+10,yy1+7,xx1+11,yy1+7);
          line(xx1+11,yy1+8,xx1+11,yy1+12);
          line(xx1+12,yy1+8,xx1+12,yy1+12);
          line(xx1+10,yy1+13,xx1+11,yy1+13);
          line(xx1+5,yy1+14,xx1+9,yy1+14);
          line(xx1+3,yy1+13,xx1+4,yy1+13);
          line(xx1+2,yy1+10,xx1+2,yy1+12);
          line(xx1+3,yy1+10,xx1+3,yy1+12);
        end;
      6:begin   (* "6" *)
          inc(xx1,4);inc(yy1,4);
          setcolor(black);
          line(xx1+2,yy1+2,xx1+2,yy1+12);
          line(xx1+3,yy1+2,xx1+3,yy1+12);
          line(xx1+3,yy1+1,xx1+4,yy1+1);
          line(xx1+5,yy1,xx1+9,yy1);
          line(xx1+10,yy1+1,xx1+11,yy1+1);
          line(xx1+11,yy1+2,xx1+12,yy1+2);
          line(xx1+11,yy1+3,xx1+12,yy1+3);
          line(xx1+4,yy1+7,xx1+4,yy1+7);
          line(xx1+5,yy1+6,xx1+9,yy1+6);
          line(xx1+10,yy1+7,xx1+11,yy1+7);
          line(xx1+11,yy1+8,xx1+11,yy1+12);
          line(xx1+12,yy1+8,xx1+12,yy1+12);
          line(xx1+10,yy1+13,xx1+11,yy1+13);
          line(xx1+5,yy1+14,xx1+9,yy1+14);
          line(xx1+3,yy1+13,xx1+4,yy1+13);
        end;
      7:begin   (* "7" *)
          inc(xx1,4);inc(yy1,4);
          setcolor(lightblue);
          line(xx1+3,yy1,xx1+4,yy1);
          line(xx1+4,yy1+1,xx1+10,yy1+1);
          line(xx1+6,yy1+2,xx1+8,yy1+2);
          line(xx1+10,yy1,xx1+11,yy1);
          line(xx1+11,yy1+1,xx1+11,yy1+1);
          line(xx1+11,yy1+2,xx1+5,yy1+14);
        end;
      8:begin   (* "8" *)
          inc(xx1,4);inc(yy1,4);
          setcolor(lightred);
          line(xx1+5,yy1,xx1+9,yy1);
          line(xx1+10,yy1+1,xx1+11,yy1+1);
          line(xx1+11,yy1+2,xx1+11,yy1+4);
          line(xx1+12,yy1+2,xx1+12,yy1+4);
          line(xx1+10,yy1+5,xx1+11,yy1+5);
          line(xx1+4,yy1+6,xx1+10,yy1+6);
          line(xx1+10,yy1+7,xx1+11,yy1+7);
          line(xx1+11,yy1+8,xx1+11,yy1+12);
          line(xx1+12,yy1+8,xx1+12,yy1+12);
          line(xx1+10,yy1+13,xx1+11,yy1+13);
          line(xx1+5,yy1+14,xx1+9,yy1+14);
          line(xx1+3,yy1+13,xx1+4,yy1+13);
          line(xx1+2,yy1+8,xx1+2,yy1+12);
          line(xx1+3,yy1+8,xx1+3,yy1+12);
          line(xx1+3,yy1+7,xx1+4,yy1+7);
          line(xx1+3,yy1+5,xx1+4,yy1+5);
          line(xx1+2,yy1+2,xx1+2,yy1+4);
          line(xx1+3,yy1+2,xx1+3,yy1+4);
          line(xx1+3,yy1+1,xx1+4,yy1+1);
        end;
      10:begin   (* MINE QUI EXPLOSE *)
           setcolor(white);
           line(xx1+9,yy1+11,xx1+9,yy1+11);
           line(xx1+10,yy1+10,xx1+10,yy1+11);
           line(xx1+11,yy1+11,xx1+11,yy1+13);
           line(xx1+12,yy1+9,xx1+12,yy1+12);
           line(xx1+13,yy1+11,xx1+13,yy1+11);
           setcolor(yellow);
           line(xx1+8,yy1+11,xx1+8,yy1+11);
           line(xx1+9,yy1+10,xx1+9,yy1+10);
           line(xx1+9,yy1+13,xx1+9,yy1+13);
           line(xx1+10,yy1+9,xx1+10,yy1+9);
           line(xx1+10,yy1+12,xx1+10,yy1+13);
           line(xx1+11,yy1+9,xx1+11,yy1+10);
           line(xx1+12,yy1+8,xx1+12,yy1+8);
           line(xx1+13,yy1+8,xx1+13,yy1+10);
           line(xx1+13,yy1+12,xx1+13,yy1+13);
           line(xx1+14,yy1+10,xx1+14,yy1+11);
           setcolor(lightred);
           line(xx1+3,yy1+11,xx1+3,yy1+11);
           line(xx1+3,yy1+18,xx1+3,yy1+18);
           line(xx1+4,yy1+11,xx1+4,yy1+11);
           line(xx1+4,yy1+16,xx1+4,yy1+17);
           line(xx1+5,yy1+11,xx1+5,yy1+11);
           line(xx1+5,yy1+15,xx1+5,yy1+16);
           line(xx1+6,yy1+6,xx1+6,yy1+6);
           line(xx1+6,yy1+10,xx1+6,yy1+11);
           line(xx1+6,yy1+13,xx1+6,yy1+15);
           line(xx1+7,yy1+7,xx1+7,yy1+8);
           line(xx1+7,yy1+10,xx1+7,yy1+11);
           line(xx1+7,yy1+13,xx1+7,yy1+14);
           line(xx1+8,yy1+4,xx1+8,yy1+4);
           line(xx1+8,yy1+8,xx1+8,yy1+10);
           line(xx1+8,yy1+16,xx1+8,yy1+17);
           line(xx1+9,yy1+8,xx1+9,yy1+9);
           line(xx1+9,yy1+15,xx1+9,yy1+15);
           line(xx1+10,yy1+6,xx1+10,yy1+8);
           line(xx1+10,yy1+14,xx1+10,yy1+15);
           line(xx1+10,yy1+19,xx1+10,yy1+19);
           line(xx1+11,yy1+3,xx1+11,yy1+8);
           line(xx1+11,yy1+14,xx1+11,yy1+14);
           line(xx1+11,yy1+17,xx1+11,yy1+18);
           line(xx1+12,yy1+6,xx1+12,yy1+7);
           line(xx1+12,yy1+13,xx1+12,yy1+14);
           line(xx1+13,yy1+14,xx1+13,yy1+15);
           line(xx1+14,yy1+7,xx1+14,yy1+9);
           line(xx1+14,yy1+12,xx1+14,yy1+16);
           line(xx1+15,yy1+7,xx1+15,yy1+8);
           line(xx1+15,yy1+10,xx1+15,yy1+14);
           line(xx1+15,yy1+16,xx1+15,yy1+17);
           line(xx1+16,yy1+6,xx1+16,yy1+7);
           line(xx1+16,yy1+11,xx1+16,yy1+12);
           line(xx1+16,yy1+17,xx1+16,yy1+18);
           line(xx1+17,yy1+5,xx1+17,yy1+5);
           line(xx1+17,yy1+11,xx1+17,yy1+12);
           line(xx1+17,yy1+15,xx1+17,yy1+15);
           line(xx1+17,yy1+19,xx1+17,yy1+19);
           line(xx1+18,yy1+11,xx1+18,yy1+11);
           line(xx1+18,yy1+16,xx1+18,yy1+16);
           line(xx1+19,yy1+11,xx1+19,yy1+11);
         end;
    end;
  setcolor(couleurcourante);
  moveto(xcourant,ycourant);
End;


Procedure DESSINMARQUE(ligne,colonne:byte);
(* DESSIN D'UNE MARQUE SUR UNE CASE *)

Var m,n:byte;
    xx1,yy1,xx2,yy2,xx3,yy3,xx4,yy4:word;
    couleurcourante,xcourant,ycourant:word;

Begin
  xcourant:=getx;ycourant:=gety;
  couleurcourante:=getcolor;
  m:=ligne-1;
  n:=colonne-1;
  xx1:=x[25]+n*(nbpixh+1);yy1:=y[25]+m*(nbpixv+1);
  xx2:=xx1+nbpixh+1;yy2:=yy1;
  xx3:=xx1;yy3:=yy1+nbpixv+1;
  xx4:=xx2;yy4:=yy3;
  case marques[colonne,ligne] of
      0:begin   (* CASE VIDE *)
          setlinestyle(solidln,0,1);
          setcolor(cyan);
          for m:=5 to 17 do
            line(xx1+5,yy1+m,xx1+17,yy1+m);
        end;
      1:begin   (* DRAPEAU *)
          setlinestyle(solidln,0,1);
          setcolor(black);
          line(xx1+9,yy1+6,xx1+9,yy1+17);
          setcolor(lightred);
          line(xx1+10,yy1+6,xx1+10,yy1+10);
          line(xx1+11,yy1+7,xx1+11,yy1+10);
          line(xx1+12,yy1+9,xx1+12,yy1+11);
          line(xx1+13,yy1+10,xx1+13,yy1+11);
          line(xx1+14,yy1+11,xx1+14,yy1+11);
        end;
      2:begin   (* POINT D'INTERROGATION *)
          setlinestyle(solidln,0,2);
          setcolor(cyan);
          for m:=5 to 17 do
            line(xx1+5,yy1+m,xx1+17,yy1+m);
          setcolor(black);
          arc(xx1+11,yy1+8,270,360,2);
          arc(xx1+11,yy1+8,0,180,2);
          line(xx1+11,yy1+10,xx1+11,yy1+13);
          line(xx1+11,yy1+16,xx1+11,yy1+16);
        end;
      3:begin   (* CROIX *)
          setlinestyle(solidln,0,2);
          setcolor(cyan);
          for m:=5 to 17 do
            line(xx1+5,yy1+m,xx1+17,yy1+m);
          setcolor(black);
          line(xx1+7,yy1+7,xx1+15,yy1+15);
          line(xx1+7,yy1+15,xx1+15,yy1+7);
        end;
    end;
  setlinestyle(solidln,0,1);
  setcolor(couleurcourante);
  moveto(xcourant,ycourant);
End;


Procedure DESSINMENUPRINCIPAL;
(* DESSIN DU MENU DE DEMANDE DU NIVEAU DE JEU OU SORTIE DU PROGRAMME *)

Begin
  setviewport(0,0,639,479,clipon);
  clearviewport;
  setbkcolor(black);
  setlinestyle(solidln,0,1);
  (* ---"BOITIER"--- *)
  setcolor(grey);
  rectangle(90,11,548,468);
  setfillstyle(solidfill,cyan);
  floodfill(91,12,grey);
  setcolor(grey);
  line(91,12,91,467);
  line(92,13,92,467);
  line(93,467,547,467);
  line(93,466,546,466);
  setcolor(lightcyan);
  line(91,12,547,12);
  line(92,13,547,13);
  line(547,14,547,467);
  line(546,14,546,466);
  settextjustify(centertext,toptext);
  settextstyle(triplexfont,horizdir,7);
  setcolor(red);
  outtextxy(240,65,'MINES');
  settextjustify(centertext,centertext);
  settextstyle(triplexfont,horizdir,1);
  outtextxy(240,130,'Version 1.01');
  (* ---"PLAQUETTES"--- *)
  setfillstyle(solidfill,black);
  (* "DEBUTANT" *)
  setcolor(grey);
  rectangle(140,166,498,203);
  line(141,167,141,202);
  line(142,168,142,202);
  line(143,202,497,202);
  line(143,201,496,201);
  setcolor(lightcyan);
  line(141,167,497,167);
  line(142,168,497,168);
  line(497,169,497,202);
  line(496,169,496,201);
  setcolor(grey);
  rectangle(352,171,366,180);
  floodfill(353,172,grey);
  rectangle(400,171,414,180);
  floodfill(401,172,grey);
  rectangle(448,171,462,180);
  floodfill(449,172,grey);
  setcolor(brown);
  settextjustify(centertext,centertext);
  outtextxy(359,188,'F1');
  outtextxy(407,188,'F2');
  outtextxy(455,188,'F3');
  settextjustify(lefttext,centertext);
  outtextxy(170,183,'DEBUTANT');
  (* "MOYEN" *)
  setcolor(grey);
  rectangle(140,214,498,251);
  line(141,215,141,250);
  line(142,216,142,250);
  line(143,250,497,250);
  line(143,249,496,249);
  setcolor(lightcyan);
  line(141,215,497,215);
  line(142,216,497,216);
  line(497,217,497,250);
  line(496,217,496,249);
  setcolor(grey);
  rectangle(352,219,366,228);
  floodfill(353,220,grey);
  rectangle(400,219,414,228);
  floodfill(401,220,grey);
  rectangle(448,219,462,228);
  floodfill(449,220,grey);
  setcolor(red);
  settextjustify(centertext,centertext);
  outtextxy(359,236,'F4');
  outtextxy(407,236,'F5');
  outtextxy(455,236,'F6');
  settextjustify(lefttext,centertext);
  outtextxy(170,231,'MOYEN');
  (* "PRO" *)
  setcolor(grey);
  rectangle(140,262,498,299);
  line(141,263,141,298);
  line(142,264,142,298);
  line(143,298,497,298);
  line(143,297,496,297);
  setcolor(lightcyan);
  line(141,263,497,263);
  line(142,264,497,264);
  line(497,265,497,298);
  line(496,265,496,297);
  setcolor(grey);
  rectangle(352,267,366,276);
  floodfill(353,268,grey);
  rectangle(400,267,414,276);
  floodfill(401,268,grey);
  rectangle(448,267,462,276);
  floodfill(449,268,grey);
  setcolor(magenta);
  settextjustify(centertext,centertext);
  outtextxy(359,284,'F7');
  outtextxy(407,284,'F8');
  outtextxy(455,284,'F9');
  settextjustify(lefttext,centertext);
  outtextxy(170,279,'PRO');
  (* "CHRONOMETRE" *)
  setcolor(grey);
  rectangle(140,310,498,347);
  line(141,311,141,346);
  line(142,312,142,346);
  line(143,346,497,346);
  line(143,345,496,345);
  setcolor(lightcyan);
  line(141,311,497,311);
  line(142,312,497,312);
  line(497,313,497,346);
  line(496,313,496,345);
  setcolor(grey);
  rectangle(448,315,462,324);
  floodfill(449,316,grey);
  setcolor(blue);
  settextjustify(centertext,centertext);
  outtextxy(455,332,'F10');
  settextjustify(lefttext,centertext);
  outtextxy(170,327,'CHRONOMETRE');
  (* "COMMENCER LE JEU" *)
  setcolor(grey);
  rectangle(140,358,498,395);
  line(141,359,141,394);
  line(142,360,142,394);
  line(143,394,497,394);
  line(143,393,496,393);
  setcolor(lightcyan);
  line(141,359,497,359);
  line(142,360,497,360);
  line(497,361,497,394);
  line(496,361,496,393);
  setcolor(black);
  settextjustify(righttext,centertext);
  outtextxy(462,375,'ENTER');
  settextjustify(lefttext,centertext);
  outtextxy(170,375,'COMMENCER LE JEU');
  (* "QUITTER" *)
  setcolor(grey);
  rectangle(140,406,498,443);
  line(141,407,141,442);
  line(142,408,142,442);
  line(143,442,497,442);
  line(143,441,496,441);
  setcolor(lightcyan);
  line(141,407,497,407);
  line(142,408,497,408);
  line(497,409,497,442);
  line(496,409,496,441);
  setcolor(black);
  settextjustify(righttext,centertext);
  outtextxy(462,423,'ESCAPE');
  settextjustify(lefttext,centertext);
  outtextxy(170,423,'QUITTER');
  (* ---BANDES DE COULEUR VERTICALES--- *)
  setcolor(grey);
  line(340,50,377,50);
  line(340,50,340,165);
  line(377,50,377,165);

  line(388,50,425,50);
  line(388,50,388,165);
  line(425,50,425,165);

  line(436,50,473,50);
  line(436,50,436,165);
  line(473,50,473,165);

  line(340,204,340,213);
  line(377,204,377,213);

  line(388,204,388,213);
  line(425,204,425,213);

  line(436,204,436,213);
  line(473,204,473,213);

  line(340,252,340,261);
  line(377,252,377,261);

  line(388,252,388,261);
  line(425,252,425,261);

  line(436,252,436,261);
  line(473,252,473,261);

  line(340,300,340,303);
  line(377,300,377,303);
  line(340,304,377,304);

  line(388,300,388,303);
  line(425,300,425,303);
  line(388,304,425,304);

  line(436,300,436,303);
  line(473,300,473,303);
  line(436,304,473,304);
  setfillstyle(solidfill,brown);
  floodfill(341,51,grey);
  floodfill(341,204,grey);
  floodfill(341,252,grey);
  floodfill(341,300,grey);
  setfillstyle(solidfill,red);
  floodfill(389,51,grey);
  floodfill(389,204,grey);
  floodfill(389,252,grey);
  floodfill(389,300,grey);
  setfillstyle(solidfill,magenta);
  floodfill(437,51,grey);
  floodfill(437,204,grey);
  floodfill(437,252,grey);
  floodfill(437,300,grey);
  settextjustify(centertext,centertext);
  setcolor(lightgrey);
  outtextxy(359,62,'F');
  outtextxy(359,77,'O');
  outtextxy(359,92,'R');
  outtextxy(359,107,'C');
  outtextxy(359,122,'E');
  outtextxy(359,152,'1');
  outtextxy(407,62,'F');
  outtextxy(407,77,'O');
  outtextxy(407,92,'R');
  outtextxy(407,107,'C');
  outtextxy(407,122,'E');
  outtextxy(407,152,'2');
  outtextxy(455,62,'F');
  outtextxy(455,77,'O');
  outtextxy(455,92,'R');
  outtextxy(455,107,'C');
  outtextxy(455,122,'E');
  outtextxy(455,152,'3');
End;


Procedure LOUPIOTTE(fonction,couleur:word);
(* DANS LE MENU PRINCIPAL, ALLUME OU ETEINT UNE "LAMPE" *)

Var x,y,n,couleurcourante,xcourant,ycourant:word;

Begin
  case fonction of
      1:begin x:=352;y:=171; end;
      2:begin x:=400;y:=171; end;
      3:begin x:=448;y:=171; end;
      4:begin x:=352;y:=219; end;
      5:begin x:=400;y:=219; end;
      6:begin x:=448;y:=219; end;
      7:begin x:=352;y:=267; end;
      8:begin x:=400;y:=267; end;
      9:begin x:=448;y:=267; end;
      10:begin x:=448;y:=315; end;
    end;
  xcourant:=getx;ycourant:=gety;
  couleurcourante:=getcolor;
  setfillstyle(solidfill,couleur);
  floodfill(x+1,y+1,grey);
  setcolor(couleurcourante);
  moveto(xcourant,ycourant);
End;


Procedure MESSAGEFINDEPARTIE(casesrestantes:integer);
(* FELICITATIONS OU NOMBRE DE CASES NON DEVOILEES *)

Var ligne:word;
    message,strng:string;

Begin
  settextstyle(triplexfont,horizdir,3);
  case niveau of
      1,2,3:ligne:=345;
      4,5,6:ligne:=358;
      7,8,9:ligne:=446;
    end;
  case casesrestantes of
      -1:begin   (* TEMPS ECOULE *)
           setcolor(lightred);
           outtextxy(319,ligne,'LE TEMPS EST ECOULE...');
         end;
      0:begin   (* GAGNE ! *)
          setcolor(yellow);
          outtextxy(319,ligne,'FELICITATIONS !');
        end;
    else   (* PERDU *)
      begin
        message:='IL RESTE ';
        str(casesrestantes,strng);
        message:=concat(message,strng);
        if casesrestantes=1
           then message:=concat(message,' SEULE CASE NON DEVOILEE.')
           else message:=concat(message,' CASES NON DEVOILEES.');
        setcolor(lightblue);
        outtextxy(319,ligne,message);
      end;
    end;
  settextstyle(triplexfont,horizdir,1);
End;


Procedure MESSAGEDERREUR(erreur:byte);
(* PROCEDURE D'AFFICHAGE MESSAGE ERREUR DISQUE *)

Var ligne:word;
    message:string;

Begin
  case niveau of
      1,2,3:ligne:=400;
      4,5,6:ligne:=410;
      7,8,9:ligne:=425;
    end;
  (* DESSIN DE LA PLANCHE *)
  setcolor(grey);
  rectangle(0,ligne,639,ligne+52);
  setfillstyle(solidfill,red);
  floodfill(1,ligne+1,grey);
  setcolor(black);
  line(0,ligne,0,ligne+52);
  line(1,ligne+1,1,ligne+51);
  line(2,ligne+2,2,ligne+51);
  line(0,ligne+52,639,ligne+52);
  line(3,ligne+51,638,ligne+51);
  line(3,ligne+50,637,ligne+50);
  setcolor(lightred);
  line(1,ligne+1,638,ligne+1);
  line(2,ligne+2,638,ligne+2);
  line(638,ligne+3,638,ligne+51);
  line(637,ligne+3,637,ligne+50);
  (* TEXTE DU MESSAGE D'ERREUR *)
  setcolor(yellow);
  case erreur of
      1:message:='ERREUR de Creation du Fichier MINES.RES';
      2:message:='ERREUR d''Ecriture du Fichier MINES.RES';
      3:message:='ERREUR de Lecture du Fichier MINES.RES';
      4:message:='ERREUR d''Ouverture du Fichier MINES.RES';
      10:message:='ERREUR de Lecture du Disque';
    end;
  settextstyle(triplexfont,horizdir,1);
  settextjustify(centertext,centertext);
  outtextxy(319,ligne+13,message);
  outtextxy(319,ligne+34,'R = Recommencer, A = Abandonner : _');
End;


Procedure TABLENOMJOUEUR;
(* TABLE GRAPHIQUE DE LECTURE DU NOM DU JOUEUR *)

Var ligne:word;

Begin
  case niveau of
      1,2,3:ligne:=400;
      4,5,6:ligne:=410;
      7,8,9:ligne:=425;
    end;
  setcolor(grey);
  rectangle(170,ligne,469,ligne+52);
  setfillstyle(solidfill,lightgrey);
  floodfill(171,ligne+1,grey);
  setcolor(grey);
  line(171,ligne+1,171,ligne+51);
  line(172,ligne+2,172,ligne+51);
  line(173,ligne+51,468,ligne+51);
  line(173,ligne+50,467,ligne+50);
  setcolor(white);
  line(171,ligne+1,468,ligne+1);
  line(172,ligne+2,468,ligne+2);
  line(468,ligne+3,468,ligne+51);
  line(467,ligne+3,467,ligne+50);
  (* PLAQUETTE SOUS LA LECTURE DU NOM *)
  setcolor(grey);
  rectangle(210,ligne+22,430,ligne+47);
  line(211,ligne+23,211,ligne+46);
  line(212,ligne+24,212,ligne+46);
  line(213,ligne+46,429,ligne+46);
  line(213,ligne+45,428,ligne+45);
  setcolor(white);
  line(211,ligne+23,429,ligne+23);
  line(212,ligne+24,429,ligne+24);
  line(429,ligne+25,429,ligne+46);
  line(428,ligne+25,428,ligne+45);
  setcolor(red);
  settextstyle(triplexfont,horizdir,1);
  settextjustify(centertext,centertext);
  outtextxy(319,ligne+9,'Votre nom :');
End;


Procedure LETTRENOM(lettre:char;place:byte);
(* AFFICHAGE LETTRE OU CURSEUR LORS DE LA LECTURE DU NOM DU JOUEUR *)

Var l,ligne,colonne:word;

Begin
  case niveau of
      1,2,3:ligne:=425;
      4,5,6:ligne:=435;
      7,8,9:ligne:=450;
    end;
  colonne:=220+(20*(place-1));
  setcolor(lightgrey);
  settextstyle(triplexfont,horizdir,1);
  settextjustify(centertext,centertext);
  case lettre of
      ' ':begin
            setcolor(lightgrey);
            for l:=ligne+1 to ligne+18 do
              line(colonne,l,colonne+19,l);
          end;
    else
      begin
        setcolor(magenta);
        outtextxy(colonne+9,ligne+7,lettre);
      end;
    end;
End;


Procedure EFFACERBASECRAN;
   (* EFFACEMENT LECTURE NOM JOUEUR OU MESSAGE D'ERREUR DISQUE *)

Var ligne:word;

Begin
  case niveau of
      1,2,3:ligne:=400;
      4,5,6:ligne:=410;
      7,8,9:ligne:=425;
    end;
  setviewport(0,ligne,639,ligne+52,clipon);
  clearviewport;
  setviewport(0,0,639,479,clipon);
End;


Procedure PLAQUETTERESULTAT(n:byte);
(* FOND D'UNE LIGNE D'AFFICHAGE DU CLASSEMENT. n = LIGNE A DESSINER *)

Var x,y:word;
    strng:string;

Begin
  x:=76;
  case n of
      1:y:=178;
      2:y:=213;
      3:y:=248;
      4:y:=283;
      5:y:=318;
    end;
  (* NUMERO D'ORDRE DANS LE CLASSEMENT *)
  setcolor(grey);
  rectangle(x,y,x+29,y+29);
  setcolor(black);
  line(x,y,x,y+29);
  line(x+1,y+1,x+1,y+28);
  line(x+2,y+2,x+2,y+28);
  line(x,y+29,x+29,y+29);
  line(x+3,y+28,x+28,y+28);
  line(x+3,y+27,x+27,y+27);
  setcolor(yellow);
  line(x+1,y+1,x+28,y+1);
  line(x+2,y+2,x+28,y+2);
  line(x+28,y+3,x+28,y+28);
  line(x+27,y+3,x+27,y+27);
  settextstyle(triplexfont,horizdir,1);
  settextjustify(centertext,centertext);
  str(n,strng);
  outtextxy(x+15,y+12,strng);
  (* NOM DU JOUEUR *)
  setcolor(grey);
  rectangle(x+40,y,x+219,y+29);
  setcolor(black);
  line(x+40,y,x+40,y+29);
  line(x+41,y+1,x+41,y+28);
  line(x+42,y+2,x+42,y+28);
  line(x+40,y+29,x+219,y+29);
  line(x+43,y+28,x+218,y+28);
  line(x+43,y+27,x+217,y+27);
  setcolor(yellow);
  line(x+41,y+1,x+218,y+1);
  line(x+42,y+2,x+218,y+2);
  line(x+218,y+3,x+218,y+28);
  line(x+217,y+3,x+217,y+27);
  settextjustify(lefttext,centertext);
  outtextxy(x+51,y+12,podiumniveau[n].nomjoueur);
  (* DATE *)
  setcolor(grey);
  rectangle(x+230,y,x+409,y+29);
  setcolor(black);
  line(x+230,y,x+230,y+29);
  line(x+231,y+1,x+231,y+28);
  line(x+232,y+2,x+232,y+28);
  line(x+230,y+29,x+409,y+29);
  line(x+233,y+28,x+408,y+28);
  line(x+233,y+27,x+407,y+27);
  setcolor(yellow);
  line(x+231,y+1,x+408,y+1);
  line(x+232,y+2,x+408,y+2);
  line(x+408,y+3,x+408,y+28);
  line(x+407,y+3,x+407,y+27);
  settextjustify(centertext,centertext);
  outtextxy(x+319,y+12,podiumniveau[n].date);
  (* TEMPS TOTAL *)
  setcolor(grey);
  rectangle(x+420,y,x+487,y+29);
  setcolor(black);
  line(x+420,y,x+420,y+29);
  line(x+421,y+1,x+421,y+28);
  line(x+422,y+2,x+422,y+28);
  line(x+420,y+29,x+487,y+29);
  line(x+423,y+28,x+486,y+28);
  line(x+423,y+27,x+485,y+27);
  setcolor(yellow);
  line(x+421,y+1,x+486,y+1);
  line(x+422,y+2,x+486,y+2);
  line(x+486,y+3,x+486,y+28);
  line(x+485,y+3,x+485,y+27);
  str(podiumniveau[n].tempstotal,strng);
  outtextxy(x+453,y+12,strng);
End;


Procedure TABLERESULTAT;
(* FOND GRAPHIQUE D'AFFICHAGE DU CLASSEMENT *)

Var ligne:byte;

Begin
  setviewport(0,0,639,479,clipon);
  clearviewport;
  (* PLANCHE DU FOND *)
  setcolor(grey);
  rectangle(50,120,589,358);
  setfillstyle(solidfill,brown);
  floodfill(51,121,grey);
  setcolor(black);
  line(50,120,50,358);
  line(51,121,51,357);
  line(52,122,52,357);
  line(50,358,589,358);
  line(53,357,588,357);
  line(53,356,587,356);
  setcolor(yellow);
  line(51,121,588,121);
  line(52,122,588,122);
  line(588,123,588,357);
  line(587,123,587,356);
  (* BOUTONS DE COMMANDE *)
  setcolor(grey);
  rectangle(273,131,309,167);
  rectangle(329,131,365,167);
  setfillstyle(solidfill,cyan);
  floodfill(274,132,grey);
  floodfill(330,132,grey);
  setcolor(grey);
  line(274,132,274,166);
  line(275,133,275,165);
  line(276,166,308,166);
  line(276,165,307,165);
  line(330,132,330,166);
  line(331,133,331,165);
  line(332,166,364,166);
  line(332,165,363,165);
  setcolor(lightcyan);
  line(274,132,308,132);
  line(275,133,308,133);
  line(308,134,308,166);
  line(307,134,307,165);
  line(330,132,364,132);
  line(331,133,364,133);
  line(364,134,364,166);
  line(363,134,363,165);
  TOUCHEDECOMMANDE(1,273,131);
  TOUCHEDECOMMANDE(2,329,131);
  (* PLAQUETTES SOUS LE TEXTE *)
  for ligne:=1 to 5 do
    PLAQUETTERESULTAT(ligne);
End;


END.
